# This file is part of hmnoweb, a RefineryCMS based Webapp for heavymetal.no
# Copyright (C) 2018  Harald Eilertsen <haraldei@anduin.net>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License version 3
# as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

namespace :deploy do
  desc 'Configure Puma'
  task :configure_puma do
    target_file = File.join(shared_path, 'config', 'puma.rb')
    on roles(:app) do
      unless test "[ -f #{target_file} ]"
        template = ERB.new(IO.read(File.join(Dir.pwd, 'config', 'deploy', 'templates', 'puma.rb.erb')))
        upload!(StringIO.new(template.result(binding)), target_file)
      end
    end
  end

  before 'deploy:finishing', 'deploy:generate_secret_token'
end

# :mode=ruby:
